namespace Wind
{
    using System;
    using Eco.Gameplay.Components;
    using Eco.Gameplay.DynamicValues;
    using Eco.Shared.Serialization;
    using Eco.Shared.Localization;
    using Eco.World;
    using Eco.World.Blocks;
    using Eco.Gameplay.Items;
    using Eco.Mods.TechTree;
    using Eco.Gameplay.Skills;
    using Eco.Gameplay.Systems.TextLinks;

    [Serialized]
    [Solid, Wall, Constructed]
    public class GuardrailBlock : Block, IRepresentsItem
    {
        public Type RepresentedItemType { get { return typeof(GuardrailBlockItem); } }
    }

    [Serialized]
    [MaxStackSize(20)]
    public partial class GuardrailBlockItem : BlockItem<GuardrailBlock>
    {
        public override LocString DisplayName { get { return Localizer.DoStr("Guardrail"); } }
        public override LocString DisplayDescription { get { return Localizer.DoStr("Guardrail"); } }
    }

    [RequiresSkill(typeof(BasicEngineeringSkill), 2)]
    public class GuardrailBlockRecipe : Recipe
    {
        public GuardrailBlockRecipe()
        {
            this.Products = new CraftingElement[]
            {
                new CraftingElement<GuardrailBlockItem>()
            };
            this.Ingredients = new CraftingElement[]
            {
                new CraftingElement<IronIngotItem>(typeof(BasicEngineeringSkill), 3, BasicEngineeringSkill.MultiplicativeStrategy, null)
            };
            this.CraftMinutes = CreateCraftTimeValue(typeof(GuardrailBlockRecipe), Item.Get<GuardrailBlockItem>().UILink(), 1f, typeof(BasicEngineeringSkill), typeof(BasicEngineeringFocusedSpeedTalent));
            this.Initialize(Localizer.DoStr("Guardrail"), typeof(GuardrailBlockRecipe));
            CraftingComponent.AddRecipe(typeof(WainwrightTableObject), this);
        }
    }
}
